--[[
XPGain by EVmaker, v0.1.9:
Simply prints out the exp gain information from killing or questing to your chat frame, and lets you see the experience status for anyone in your party that uses XPGain.
Also lets you ask for the experience information of a specific party member (if they use XPGain) and display a frame with basic experience information.

Todo:
* Remove any bugs (if any).
* Add a way for the user to change the experience brackets (from 0, 25, 40, 55, 70, and 85 percents, to whatever they wish).
]]--

-- Settings that get saved
if (not XPG_Settings) then
	XPG_Settings = {
		["OnOff"] = true,
		["UseChat"] = true,
		["Channel"] = 1,
		["Version"] = "0.1.10",
		["ShowExpWindow"] = false,
		["ShortMsg"] = false,
		["Colors"] = {
			["c85"] = {38, 255, 26},
			["c70"] = {141, 255, 1},
			["c55"] = {255, 255, 0},
			["c40"] = {255, 131, 0},
			["c25"] = {255, 75, 0},
			["c00"] = {255, 19, 23},
		},
	}
end

xpg = {}
(function()
	-- Main settings
	xpg.Settings = XPG_Settings;
	xpg.expArray = {};

	-- Default values
	xpg.percentNames = {
		["85"] = true,
		["70"] = true,
		["55"] = true,
		["40"] = true,
		["25"] = true,
		["00"] = true
	}
	xpg.ExpArray = {
		["expColor"] = nil,
		["expCurrent"] = 0,
		["expMax"] = 0,
		["expOld"] = 0,
	}
	--local thePlayer;
	xpg.player = false;
	xpg.eml = "XPGain";
	xpg.expColor = nil;
	xpg.expCurrent = 0;
	xpg.expMax = 0;
	xpg.expOld = 0;
	xpg.expChange = 0;
	xpg.expPercentGain = 0;
	xpg.expPercentLeft = 0;
	xpg.expPercent = 0;
	xpg.expNext = 0;
	xpg.currentLevel = 0;
	xpg.nextLevel = 0;
	xpg.Reps = 0;
	xpg.firstKill = false;
	xpg.debug = false;
	xpg.PartyList = {};
	xpg.PartyExp = {};
	xpg.backColor = EML_getColor("black")
	xpg.playerClass = false;

	-- Sets the defaults
	xpg.defaultSettings = {
		["OnOff"] = true,
		["UseChat"] = true,
		["Channel"] = 1,
		["Version"] = "0.1.9",
		["ShowExpWindow"] = false,
		["ShortMsg"] = false,
		["Colors"] = {
			["c85"] = {38, 255, 26}, -- Bright Green
			["c70"] = {141, 255, 1}, -- Yellow-Green
			["c55"] = {255, 255, 0}, -- Yellow
			["c40"] = {255, 131, 0}, -- Yellow-Orange
			["c25"] = {255, 75, 0}, -- Orange
			["c00"] = {255, 19, 23}, -- Bright Red
		}
	}

	-- Handles the slash commands
	xpg.SlashHandler = function(theMsg)
		msg = strtrim(strlower(theMsg or ""))
		if msg == "version" then
			EMLChat("This version of XPG is: "..xpg.defaultSettings["Version"],"chat",xpg.eml)
		elseif strmatch(msg, "reset") then
			local theChoice = strmatch(msg, "reset (.*)")
			if (theChoice == nil) then
				xpg.Reset("colors")
			elseif (theChoice == "colors") then
				xpg.Reset("colors")
			elseif (theChoice == "all") then
				xpg.Reset("all")
			else
				-- Nothing yet
			end
		elseif msg == "debug" then
			if (debugMode) then
				debugMode = false;
				EMLChat("Debug mode turned off.","chat",xpg.eml)
			else
				debugMode = true;
				EMLChat("Debug mode turned on.","chat",xpg.eml)
			end
		elseif msg == "toggle xpgain" then
			if (xpg.Settings["OnOff"]) then
				xpg.Settings["OnOff"] = false;
				EMLChat("XPGain toggled off.","chat",xpg.eml)
			else
				xpg.Settings["OnOff"] = true;
				EMLChat("XPGain toggled on.","chat",xpg.eml)
			end
			--xpg.setCheckBoxes()
		elseif msg == "toggle expwindow" then
			if (xpg.Settings["ShowExpWindow"]) then
				xpg.Settings["ShowExpWindow"] = false;
				EMLChat("Your experience will be shown in chat.","chat",xpg.eml)
			else
				xpg.Settings["ShowExpWindow"] = true;
				EMLChat("Your experience will be shown in a window.","chat",xpg.eml)
			end
			--xpg.setCheckBoxes()
		elseif msg == "toggle shortmsg" then
			if (xpg.Settings["ShortMsg"]) then
				xpg.Settings["ShortMsg"] = false;
				EMLChat("Short Experience printout is now disabled","chat",xpg.eml)
			else
				xpg.Settings["ShortMsg"] = true;
				EMLChat("Short Experience printout is now enabled","chat",xpg.eml)
			end
			--xpg.setCheckBoxes()
		elseif msg == "toggle chat" then
			if (xpg.Settings["UseChat"]) then
				xpg.Settings["UseChat"] = false;
				EMLChat("Sending experience printout to chat is now disabled","chat",xpg.eml)
			else
				xpg.Settings["UseChat"] = true;
				EMLChat("Sending experience printout to chat is now enabled","chat",xpg.eml)
			end
		elseif msg == "toggle status" then
			if (xpg.Settings["OnOff"]) then
				EMLChat("XPGain is enabled.","chat",xpg.eml)
			else
				EMLChat("XPGain is disabled.","chat",xpg.eml)
			end
			if (xpg.Settings["ShowExpWindow"]) then
				EMLChat("Player experience gains are being shown in a window.","chat",xpg.eml)
			else
				EMLChat("Player experience gains are being shown in chat.","chat",xpg.eml)
			end
			if (xpg.Settings["ShortMsg"]) then
				EMLChat("Short experience printout is enabled.","chat",xpg.eml)
			else
				EMLChat("Short experience printout is disabled.","chat",xpg.eml)
			end
			if (xpg.Settings["UseChat"]) then
				EMLChat("Sending experience printout to chat is enabled.","chat",xpg.eml)
			else
				EMLChat("Sending experience printout to chat is disabled.","chat",xpg.eml)
			end
		elseif msg == "testcolors" then
			xpg.testColors("mycolors")
		elseif msg == "test1" then
			xpg.testFunction()
		elseif msg == "test2" then
			xpg.testFunction2()
		elseif msg == "menu" then
			EMLFrame_Toggle("XPG1")
			EMLChat("Opening Menu.","chat",xpg.eml)
		elseif msg == "expwindow" then
			EMLFrame_Toggle("XPG2")
		elseif strmatch(msg, "list") then
			local theChoice = strmatch(msg, "list (.*)")
			if (theChoice ~= nil) then
				if (theChoice == "defaultcolors") then
					xpg.testColors("defaultcolors")
				elseif (theChoice == "mycolors") then
					xpg.testColors("mycolors")
				elseif (theChoice == "party") then
					EML_Display(xpg.PartyList,xpg.eml)
				else
					EMLChat("Choices are: defaultcolors, mycolors","chat",xpg.eml)
				end
			else
				EMLChat("Choices are: colors, mycolors","chat",xpg.eml)
			end
		elseif msg == "partyexp" then
			xpg.sendExp("get")
			for index,value in pairs(xpg.PartyList) do
				xpg.printExp(value)
			end
		elseif strmatch(msg, "exp") then
			local theChoice = strmatch(msg, "exp (.*)");
			if (theChoice ~= nil) then
				xpg.printExp(theChoice)
			else
				xpg.calculateExp("report")
			end
		elseif strmatch(msg, "setcolor") then
			local thePlace,theR,theG,theB = strmatch(msg, "setcolor (.*),(.*),(.*),(.*)");
			local theColor = {theR,theG,theB};
			if (thePlace and theR and theG and theB) then
				xpg.setColor(thePlace,theColor)
			else
				EMLChat("Must enter similar to /xpg setcolor percent,r,g,b or /xpg setcolor 85,231,154,10","chat",xpg.eml)
			end
		elseif strmatch(msg, "channel") then
			local theChannel = tonumber(strmatch(msg, "channel (.*)"));
			if (debugMode) then EML_Display(theChannel,xpg.eml) end
			if (theChannel) then
				getglobal("ChatFrame"..theChannel):AddMessage("XPG: ".."Will now print to this channel.", 1, 1, 0)
				xpg.Settings["Channel"] = theChannel;
			end
		elseif msg == "test1" then
			xpg.testColors()
		else
			EMLChat("XPGain","chat",xpg.eml)
			EMLChat("-------------------","chat",xpg.eml)
			EMLChat("toggle, (toggles XPGain on and off)","chat",xpg.eml)
			EMLChat("menu, (opens the color config menu)","chat",xpg.eml)
			EMLChat("expwindow, (opens or closes the player experience window)","chat",xpg.eml)
			EMLChat("exp, (prints your current experience status)","chat",xpg.eml)
			EMLChat("exp name, (prints the experience data from a party member that uses XPGain)","chat",xpg.eml)
			EMLChat("partyexp, (prints the party experience status for those using XPGain)","chat",xpg.eml)
			EMLChat("setcolor, (sets the color of different exp percentages)","chat",xpg.eml)
			EMLChat("testcolors, (prints out the experience color percentages)","chat",xpg.eml)
			EMLChat("version, (displays version information)","chat",xpg.eml)
			EMLChat("list, (choose what to list such as the colors)","chat",xpg.eml)
		end
	end

	xpg.altChat = function(msg,colors)
		local r,g,b;
		if (colors) then
			r,g,b = EML_splitTable(colors);
		end
		if (r and g and b) then
			getglobal("ChatFrame"..xpg.Settings["Channel"]):AddMessage("<XPG> "..msg, r, g, b)
		else
			if (debugMode) then EMLChat("Colors not set.","chat",xpg.eml) end
		end
	end

	-- Calculates and displays the players current experience
	xpg.calculateExp = function(where)
		if (xpg.expCurrent == 0) then
			EMLChat("First experience gain of session, starting.","chat",xpg.eml,"teal")
			xpg.expCurrent = UnitXP("player");
			xpg.expOld = xpg.expCurrent;
			xpg.currentLevel = UnitLevel("player");
			return;
		end
		xpg.expPercent = ((floor((UnitXP("player") / UnitXPMax("player")) * 10000)) / 100);
		if (xpg.expPercent > 85) then
			xpg.expColor = xpg["Settings"]["Colors"].c85;
		elseif (xpg.expPercent > 70) then
			xpg.expColor = xpg["Settings"]["Colors"].c70;
		elseif (xpg.expPercent > 55) then
			xpg.expColor = xpg["Settings"]["Colors"].c55;
		elseif (xpg.expPercent > 40) then
			xpg.expColor = xpg["Settings"]["Colors"].c40;
		elseif (xpg.expPercent > 25) then
			xpg.expColor = xpg["Settings"]["Colors"].c25;
		else
			xpg.expColor = xpg["Settings"]["Colors"].c00;
		end
		local textR,textG,textB = EML_splitTable(xpg.expColor);
		xpg.Class = UnitClass("player");
		xpg.expCurrent = UnitXP("player");
		xpg.expMax = UnitXPMax("player");
		xpg.expChange = (xpg.expCurrent - xpg.expOld);
		xpg.expNext = (xpg.expMax - xpg.expCurrent);
		xpg.expPercentGain = (xpg.expCurrent/xpg.expMax)*100;
		xpg.expPercentLeft = strsub(((xpg.expNext/xpg.expMax)*100),1,5);
		xpg.expOld = xpg.expCurrent;

		xpg.currentLevel = UnitLevel("player");
		xpg.nextLevel = xpg.currentLevel + 1;

		xpg.Reps = (floor(xpg.expNext/xpg.expChange)) + 1;

		local Msg = "";
		local Msg2 = "";
		-- For print to chat on exp gain
		-- Amount of XP gained.
		Msg = Msg.."+"..xpg.expChange.."XP. "
		-- Percentage of this level completed.
		Msg = Msg.."("..xpg.expPercent.."%) "
		-- Amount of XP till next level.
		Msg = Msg..xpg.expNext.."XP ("..xpg.expPercentLeft.."%) to go. "
		-- Repititions till level
		Msg = Msg..xpg.Reps.." Repetitions."
		-- For report when directly asked
		-- Current Level
		Msg2 = Msg2.."Level "..xpg.currentLevel.." "..xpg.Class..", "
		-- Percentage of this level completed.
		Msg2 = Msg2..xpg.expPercent.."% of the way to "..xpg.nextLevel..", with "
		-- Amount of XP till next level.
		Msg2 = Msg2..xpg.expNext.."XP ("..xpg.expPercentLeft.."%) to go. "
		-- Write message to chat window during normal exp gain.
		local ShortMsg = "";
		local ShortMsg2 = "";
		ShortMsg = ShortMsg.."You gained "..xpg.expChange.."XP, "..xpg.expPercentLeft.."% to go.";
		ShortMsg2 = ShortMsg2.."You are "..xpg.expPercent.."% of the way to "..(xpg.currentLevel+1)..".";
		if (not tonumber(xpg.Reps)) then
			return nil;
		end
		if (not xpg.Settings["UseChat"] or xpg.expChange < 1) and (where ~= "report") then return false; end
		if (where == nil) and (xpg.Settings["Channel"] == 1) and xpg.Settings["ShortMsg"] then
			EMLChat(ShortMsg,"chat",xpg.eml,xpg.expColor)
			return true;
		elseif (where == nil) and (xpg.Settings["Channel"] ~= 1) and xpg.Settings["ShortMsg"] then
			xpg.altChat(ShortMsg,xpg.expColor)
			return true;
		elseif (where == "report") and (xpg.Settings["Channel"] == 1) and xpg.Settings["ShortMsg"] then
			EMLChat(ShortMsg2,"chat",xpg.eml,xpg.expColor)
			return true;
		elseif (where == "report") and (xpg.Settings["Channel"] ~= 1) and xpg.Settings["ShortMsg"] then
			xpg.altChat(ShortMsg2,xpg.expColor)
			return true;
		end
		if (where == nil) and (xpg.Settings["Channel"] == 1) then
			EMLChat(Msg,"chat",xpg.eml,xpg.expColor)
		elseif (where == nil) and (xpg.Settings["Channel"] ~= 1) then
			xpg.altChat(Msg,xpg.expColor)
		-- Write message to chat on request.
		elseif (where == "report") and (xpg.Settings["Channel"] == 1) then
			EMLChat(Msg2,"chat",xpg.eml,xpg.expColor)
		elseif (where == "report") and (xpg.Settings["Channel"] ~= 1) then
			xpg.altChat(Msg2,xpg.expColor)
		elseif (where == "window") then
			EMLFrame_Toggle("XPG2","open")
			XPG2_Color:SetVertexColor(backR,backG,backB);
			XPG2_textExp:SetText(Msg)
			XPG2_textExp:SetTextColor(textR,textG,textB)
		else
			-- Do nothing
		end
	end

	-- Allows the user to set the color of a percentage
	xpg.setColor = function(where,theColor)
		local theR,theG,theB = EML_splitWoWTable(theColor);
		-- 85, 70, 55, 40, 25, 00
		if (theR and theG and theB) then
			if (EML_findTable(where,xpg.percentNames)) then
				local newColor = {theR,theG,theB};
				xpg["Settings"]["Colors"]["c"..(where)]=newColor;
				if (debugMode) then EML_Display(xpg["Settings"]["Colors"],xpg.eml) end
			else
				EMLChat("Must be either the 85, 70, 55, 40, 25, or 00 percent marker for the color change.","chat",xpg.eml)
			end
		else
			EMLChat("Must enter valid percent and RGB color values (such as /xpg setcolor 85,175,125,10)","chat",xpg.eml)
		end
	end

	-- Displays the default colors
	xpg.testColors = function(what)
		if (what == "defaultcolors") then
			EMLChat("Displaying default colors.","chat",xpg.eml,"teal")
			-- 85% +
			EMLChat("+1XP. (85%) 15XP to go.  15 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c85)
			-- 70% +
			EMLChat("+1XP. (70%) 30XP to go.  30 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c70)
			-- 55% +
			EMLChat("+1XP. (55%) 45XP to go.  45 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c55)
			-- 40% +
			EMLChat("+1XP. (40%) 60XP to go.  60 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c40)
			-- 25% +
			EMLChat("+1XP. (25%) 75XP to go.  75 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c25)
			-- 0% +
			EMLChat("+1XP. (1%) 99XP to go.  99 Repititions.","plainchat",nil,xpg["defaultSettings"]["Colors"].c00)
			EMLChat("End of colors.","chat",xpg.eml,"teal")
		elseif (what == "mycolors") then
			EMLChat("Displaying your colors.","chat",xpg.eml,"teal")
			-- 85% +
			EMLChat("+1XP. (85%) 15XP to go.  15 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c85)
			-- 70% +
			EMLChat("+1XP. (70%) 30XP to go.  30 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c70)
			-- 55% +
			EMLChat("+1XP. (55%) 45XP to go.  45 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c55)
			-- 40% +
			EMLChat("+1XP. (40%) 60XP to go.  60 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c40)
			-- 25% +
			EMLChat("+1XP. (25%) 75XP to go.  75 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c25)
			-- 0% +
			EMLChat("+1XP. (1%) 99XP to go.  99 Repititions.","plainchat",nil,xpg["Settings"]["Colors"].c00)
			EMLChat("End of colors.","chat",xpg.eml,"teal")
		else
			if (debugMode) then EMLChat("Entered wrong display option.","chat",xpg.eml) end
		end
	end

	-- Resets settings
	xpg.Reset = function(what)
		local localColors = EML_copyTable(xpg["defaultSettings"]["Colors"]);
		local localSettings = EML_copyTable(xpg["defaultSettings"]);
		xpg["Settings"] = EML_mergeTable(xpg["Settings"],localSettings);
		EML_clearTable(xpg.PartyExp)
		xpg.populateParty()
		if (what == "version") then
			xpg["Settings"].Version = localSettings.Version;
			EMLChat("Version is different, updating settings.","chat",xpg.eml)
		elseif (what == "colors") then
			EML_clearTable(xpg["Settings"].Colors)
			xpg["Settings"].Colors = localColors;
			EMLChat("Colors reset to defaults.","chat",xpg.eml)
		else
			EML_clearTable(xpg["Settings"])
			xpg["Settings"] = localSettings;
			EMLChat("All settings reset.","chat",xpg.eml)
		end
	end

	-- Fills the party list
	xpg.populateParty = function()
		EML_clearTable(xpg.PartyList)
		for Count = 1,GetNumSubgroupMembers() do
			local theName = UnitName("party"..Count);
			if (theName) then
				EML_addTable(string.lower(tostring(theName)),xpg.PartyList)
			else
				if (xpg.debug) then EMLChat("Not a name.","chat",xpg.eml,"red") end
			end
		end
		if (xpg.debug) then eml.sdisplay(xpg.PartyList) end
	end

	-- Records party member experience information.
	xpg.expUpdate = function(who,minXP,maxXP)
		local theWho = string.lower(who);
		xpg.populateParty()
		for index,value in pairs(xpg.PartyList) do
			if (theWho == value) then
				xpg.PartyExp[index]={minXP,maxXP};
			else
				-- Do nothing
			end
		end
	end

	-- Formats party member experience data for printing.
	xpg.getExp = function(who)
		local theWho = string.lower(who);
		local theIndex = nil;
		local expReturned = nil;
		for index,value in pairs(xpg.PartyList) do
			if (value == theWho) then
				theIndex = index;
			end
		end
		for index2,value2 in pairs(xpg.PartyExp) do
			if (index2 == theIndex) then
				local minExp,maxExp = EML_splitTwo(value2);
				local percTo,percLeft,expLeft;
				local whoParty = (tostring("party"..theIndex));
				local curLevel = (UnitLevel(whoParty));
				local curClass = (UnitClass(whoParty));
				if (minExp ~= nil and maxExp ~= nil) then
					minExp = tonumber(minExp);
					maxExp = tonumber(maxExp);
					expLeft = (maxExp-minExp);
					percTo = ((floor((minExp/maxExp)*10000))/100);
					percLeft = (strsub((((maxExp-minExp)/maxExp)*100),1,5))
				end
				if (minExp ~= nil and maxExp ~= nil) then
					expReturned = {
						["MinExp"] = minExp,
						["MaxExp"] = maxExp,
						["ExpLeft"] = expLeft,
						["PercTo"] = percTo,
						["PercLeft"] = percLeft,
						["CurLevel"] = curLevel,
						["CurClass"] = curClass,
					}
					return expReturned;
				end
			end
		end
	end

	-- Prints party member experience information to chat.
	xpg.printExp = function(who)
		local theWho = string.lower(who);
		local expInfo = xpg.getExp(theWho);
		if (debugMode) then EML_Display(expInfo,xpg.eml) end
		local Msg="";
		if (expInfo) then
			-- Current Level
			Msg = Msg..theWho.." is a Level "..expInfo.CurLevel.." "..expInfo.CurClass..", "
			-- Percentage of this level completed.
			Msg = Msg..expInfo.PercTo.."% of the way to "..(expInfo.CurLevel+1)..", with "
			-- Amount of XP till next level.
			Msg = Msg..expInfo.ExpLeft.."XP ("..expInfo.PercLeft.."%) to go. "
			-- Write message to chat on request.
			if (xpg["Settings"]["Channel"] == 1) then
				EMLChat(Msg,"chat",xpg.eml)
			else
				xpg.altChat(Msg,xpg["Settings"]["Colors"].c85)
			end
		else
			if (who ~= nil) then EMLChat(theWho.." has no experience data.","chat",xpg.eml,"teal") end
		end
	end

	-- Sends experience updates or requests experience updates to party members.
	xpg.sendExp = function(what)
		if (what == "send") then
			C_ChatInfo.SendAddonMessage("XPG","PLAYER_XP_UPDATE"..","..UnitXP("player")..","..UnitXPMax("player"),"PARTY")
		end
		if (what == "get") then
			C_ChatInfo.SendAddonMessage("XPG","PLAYER_XP_UPDATE"..","..UnitXP("player")..","..UnitXPMax("player"),"PARTY")
			C_ChatInfo.SendAddonMessage("XPG","REQUEST_XP_UPDATE","PARTY")
		end
	end

	-- Functions compatible with the GUI
	--[[
	xpg.GUIColors = function(what)
		if (what == "reset") then
			xpg.Reset("colors")
		elseif (what == "set") then
			local userPercent=XPG1_Percent:GetText();
			local userR=tonumber(XPG1_RVal:GetText());
			local userG=tonumber(XPG1_GVal:GetText());
			local userB=tonumber(XPG1_BVal:GetText());
			local userColor;
			if (userR and userG and userB) then
				userColor={userR,userG,userB};
			end
			if (EML_findTable(userPercent,xpg.percentNames)) then
				if (userColor) then
					EMLChat("Red is: "..userR..", Green is: "..userG..", Blue is: "..userB,"chat",xpg.eml,userColor)
					xpg["Settings"]["Colors"]["c"..userPercent]=userColor;
				else
					EMLChat("Must enter valid Red, Green and Blues values (between 0 and 255)","chat",xpg.eml)
				end
			else
				EMLChat("Valid experience percents are: 85, 70, 55, 40, 25 and 00","chat",xpg.eml)
			end
		else
			-- Nothing yet
		end
	end

	xpg.GUIColorPicker = function(what)
		-- 85, 70, 55, 40, 25, 00
		if (what == "open") then
			EML_colorPicker("open")
		elseif (what == "setcolor") then
			local userPercent=XPG1_Percent:GetText();
			if (EML_findTable(userPercent,xpg.percentNames)) then
				local chosenColor = EML_colorPicker();
				local theR,theG,theB = EML_splitWoWTable(chosenColor);
				EMLChat("Red is: "..theR..", Green is: "..theG..", Blue is: "..theB,"chat",xpg.eml,chosenColor)
				xpg["Settings"]["Colors"]["c"..userPercent]=chosenColor;
			else
				EMLChat("Valid experience percents are: 85, 70, 55, 40, 25, and 00","chat",xpg.eml)
			end
		else
			-- Nothing yet
		end
	end

	xpg.checkCheckBoxes = function()
		if (XPG1_OnOff:GetChecked()) then
			xpg.Settings["OnOff"]=true;
		else
			xpg.Settings["OnOff"]=false;
		end
		if (XPG1_ExpWindow:GetChecked()) then
			xpg.Settings["ShowExpWindow"]=true;
		else
			xpg.Settings["ShowExpWindow"]=false;
		end
		if (XPG1_ShortMsg:GetChecked()) then
			xpg.Settings["ShortMsg"]=true;
		else
			xpg.Settings["ShortMsg"]=false;
		end
		XPG_Settings = xpg.Settings
	end
	
	xpg.setCheckBoxes = function()
		if (xpg.Settings["OnOff"]) then
			XPG1_OnOff:SetChecked(true)
		else
			XPG1_OnOff:SetChecked(nil)
		end
		if (xpg.Settings["ShowExpWindow"]) then
			XPG1_ExpWindow:SetChecked(true)
		else
			XPG1_ExpWindow:SetChecked(nil)
		end
		if (xpg.Settings["ShortMsg"]) then
			XPG1_ShortMsg:SetChecked(true)
		else
			XPG1_ShortMsg:SetChecked(false)
		end
	end
	]]--

	xpg.testFunction = function()
		--local theColors = xpg["defaultSettings"]["Colors"]["c55"];
		--xpg.altChat("test message",theColors)
		local expWindowLocal = xpg.Settings.ShowExpWindow;
		local expWindowSaved = XPG_Settings.ShowExpWindow;
		eml.print("Local XP Window:",xpg.eml,"teal")
		eml.display(expWindowLocal)
		eml.print("Saved XP Window:",xpg.eml,"teal")
		eml.display(expWindowSaved)	
	end

	xpg.testFunction2 = function()
		local xpWindow = XPG2_textExp;
	end
end)()

-- Handles setup
XPG_OnLoad = function(self)
	self:RegisterEvent("PLAYER_XP_UPDATE")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	self:RegisterEvent("CHAT_MSG_ADDON")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	--self:RegisterEvent("PARTY_MEMBERS_CHANGED")
	local prefix = C_ChatInfo.RegisterAddonMessagePrefix("XPG")
	EMLChat("XPGain "..xpg["defaultSettings"]["Version"].." loaded","plainchat",xpg.eml,"teal")
	if (not prefix) then EMLChat("Addon prefix could not be registered, partyexp feature will not work","plainchat",xpg.eml,"red") end
	SLASH_XPG1 = "/xpgain"
	SLASH_XPG2 = "/xpg"
	SlashCmdList["XPG"] = function(msg)
		xpg.SlashHandler(msg);
	end
end

-- Handles the events
XPG_OnEvent = function(self,event,...)
	local arg1,arg2,arg3,arg4,arg5,arg6 = ...;
	if (xpg["Settings"]["OnOff"]) then
		if (event == "PLAYER_XP_UPDATE") then
			if (xpg.expCurrent ~= 0 and xpg.Settings["ShowExpWindow"]) then
				xpg.calculateExp("window")
			elseif (xpg.expCurrent == 0 and xpg.Settings["ShowExpWindow"]) then
				xpg.calculateExp()
			elseif (not xpg.Settings["ShowExpWindow"]) then
				xpg.calculateExp()
			end
			xpg.sendExp("send")
		end
		if (event == "PLAYER_LEVEL_UP") then
			local playerLevel = UnitLevel("player");
			C_ChatInfo.SendAddonMessage("XPG","PLAYER_LEVEL_UP"..","..playerLevel,"PARTY")
		end
		if (event == "PARTY_MEMBERS_CHANGED") then
			xpg.populateParty()
			xpg.sendExp("get")
		end
	end
	if (event == "PLAYER_ENTERING_WORLD") then
		xpg.calculateExp()
		xpg.populateParty()
		xpg.sendExp("get")
		thePlayer, _ = UnitName("player");
		if (xpg["Settings"]["Version"] ~= xpg["defaultSettings"]["Version"]) then
			if (xpg.debug) then EMLChat("Version is different.","chat",xpg.eml) end
			xpg.Reset("version")
		else
			if (xpg.debug) then EMLChat("Version is the same.","chat",xpg.eml) end
		end
		xpg.playerClass = UnitClass("player");
		local listenOk = C_ChatInfo.RegisterAddonMessagePrefix("XPG")
		if (not listenOk) then
			EMLChat("XPG was not registered.","chat",xpg.eml,"red")
		end
		xpg.Settings = XPG_Settings;
		--xpg.setCheckBoxes()
	end
	if (event == "CHAT_MSG_ADDON") then
		if (arg1 == "XPG") then
			if (xpg.debug) then EMLChat("Recieved: "..arg2..", From: "..arg1,"chat",xpg.eml,"teal") end
			local addMsg = {strsplit(",", arg2)}
			local arg4 = ({strsplit("-", arg4)})[1]
			if addMsg[1] == "PLAYER_LEVEL_UP" then
				local whatLevel;
				local whoLeveled=string.lower(arg4);
				if (EML_findTable(whoLeveled,xpg.PartyList)) then
					whatLevel = addMsg[2];
					if (xpg.debug) then EMLChat(whoLeveled.." leveled to "..tostring(whatLevel),"chat",xpg.eml) end
				end
				if (whatLevel) and (xpg["Settings"]["OnOff"]) then EMLChat(arg4.." Leveled to "..(whatLevel).."!","chat",xpg.eml,"green") end
				return;
			end
			if (addMsg[1] == "PLAYER_XP_UPDATE") and (arg4 ~= thePlayer) then
				xpg.expUpdate(arg4, addMsg[2], addMsg[3])
				return;
			end
			if (addMsg[1] == "REQUEST_XP_UPDATE") and (arg4 ~= thePlayer) then
				xpg.sendExp("send")
				return;
			end
		elseif (arg1 == "UE") then
			if (xpg.debug) then EMLChat("Recieved: "..arg2..", From: "..arg1,"chat",xpg.eml,"teal") end
			local addMsg = {strsplit(",", arg2)}
			if addMsg[1] == "PLAYER_EXP" then
				-- Do something
			end
		else
			return;
		end
	end
end
-- End of code
